/*

                           e Y8b    Y8b YV3.18P888 88e
                          d8b Y8b    Y8b Y888P 888 888D
                         d888b Y8b    Y8b Y8P  888 88"
                        d888WuHan8b    Y8b Y   888 b,
                       d8888888b Y8b    Y8P    888 88b,
           8888 8888       ,e,                                  888
           8888 888820078e  " Y8b Y888P ,e e, 888,8, dP"Y ,"Y88b888
           8888 8888888 88b888 Y8b Y8P d88 88b888 " C88b "8" 888888
           8888 8888888 888888  Y8b "  888   ,888    Y88D,ee 888888
           'Y88 88P'888 888888   Y8P    "YeeP"888   d,dP "88 888888
   888 88b,                    d8  888                     888
   888 88P' e88 88e  e88 88e  d88  888 e88 88e  ,"Y88b e88 888 ,e e, 888,8,
   888 8K  d888 888bd888 8Shaoziyang88d888 888b"8" 888d888 888d88 88b888 "
   888 88b,Y888 888PY888 888P 888  888Y888 888P,ee 888Y888 888888   ,888
   888 88P' "88 88"  "88 88"  888  888 "88 88" "88 888 "88 888 "YeeP"888


  Project:       AVR ͨ Bootloader
  File:          bootcfg.h
                 
  Version:       3.1

  Compiler:      GCC 4.1.2 + AVR Studio 4.13.528

  Author:        Shaoziyang
                 Shaoziyang@gmail.com
                 http://shaoziyang.googlepages.com      or
                 http://shaoziyang.bloger.com.cn (Chinese)
  Date:          2007.9

  Modify:       Add your modify log here

  See readme.txt to get more information.

*/

#include "bootcfg.h"
#include "bootldr.h"

//ûʼַ
#define PROG_START         0x0000

//ջСС SPM_PAGESIZE
#if BUFFERSIZE < SPM_PAGESIZE
#define BUFSIZE SPM_PAGESIZE
#else
#define BUFSIZE BUFFERSIZE
#endif

//ջ
unsigned char buf[BUFSIZE];

#if BUFSIZE > 255
unsigned int bufptr, pagptr;
#else
unsigned char bufptr, pagptr;
#endif

unsigned char ch, cl;

//ǰFlashַָ
#if FLASHEND > 0xFFFFUL
unsigned long int FlashAddr;
#else
unsigned int FlashAddr;
#endif


//һFlashҳ
void write_one_page(unsigned char *buf)
{
  boot_page_erase(FlashAddr);                  //һFlashҳ
  boot_spm_busy_wait();
  for(pagptr = 0; pagptr < SPM_PAGESIZE; pagptr += 2) //Flashҳ
  {
    boot_page_fill(pagptr, buf[pagptr] + (buf[pagptr + 1] << 8));
  }
  boot_page_write(FlashAddr);                  //ҳдһFlashҳ
  boot_spm_busy_wait();                        //ȴҳ
}

//תû
void quit()
{
  boot_rww_enable();                           //ûд
  (*((void(*)(void))PROG_START))();            //ת'jmp 0'ʡռ
}

//дݵ
void WriteCom(unsigned char dat)
{
#if RS485
  RS485Enable();
#endif

  UDRREG(COMPORTNo) = dat;
  //ȴݷ
  while(!(UCSRAREG(COMPORTNo) & (1<<TXCBIT(COMPORTNo))));
  UCSRAREG(COMPORTNo) |= (1 << TXCBIT(COMPORTNo));

#if RS485
  RS485Disable();
#endif
}

//ȴ
unsigned char WaitCom()
{
  while(!DataInCom());
  return ReadCom();
}

#if VERBOSE
void putstr(const char *str)
{
  while(*str)
    WriteCom(*str++);
  WriteCom(0x0D);
  WriteCom(0x0A);
}
#endif

//CRCУ飺1021
#if BUFSIZE > 255
void crc16(unsigned char *buf)
{
  unsigned int j;
#else
void crc16(unsigned char *buf)
{
  unsigned char j;
#endif

#if CRCMODE == 0
  unsigned char i;
  unsigned int t;
#endif
  unsigned int crc;

  crc = 0;
  for(j = BUFFERSIZE; j > 0; j--)
  {
#if CRCMODE == 0
    //׼CRCУ
    crc = (crc ^ (((unsigned int) *buf) << 8));
    for(i = 8; i > 0; i--)
    {
      t = crc << 1;
      if(crc & 0x8000)
        t = t ^ 0x1021;
      crc = t;
    }
#elif CRCMODE == 1
    //ۼӺУ
    crc += (unsigned int)(*buf);
#elif

#endif
    buf++;
  }
  ch = crc / 256;
  cl = crc % 256;
}

int main(void)
{
  unsigned char cnt;
  unsigned char packNO;
  unsigned char crch, crcl;

#if InitDelay > 255
  unsigned int di;
#elif InitDelay
  unsigned char di;
#endif

#if BUFFERSIZE > 255
  unsigned int li;
#else
  unsigned char li;
#endif

  //رжϣ쳣µı
  sei();

#if WDGEn
  //ŹÿŹʱʱ
  wdt_enable(WDTO_1S);
#endif

  //ʱӳʼ:CTCģʽ
  TimerInit();

#if RS485
  DDRREG(RS485PORT) |= (1 << RS485TXEn);
  RS485Disable();
#endif

#if LEDEn
  //LED˿Ϊ״̬
  DDRREG(LEDPORT) = (1 << LEDPORTNo);
#endif

  //ڳʼ
  ComInit();

#if InitDelay
  //ĳЩͺŵĵƬҪʱ򴮿ڷ
  for(di = InitDelay; di > 0; di--)
    __asm__ __volatile__ ("nop": : );
#endif

#if LEVELMODE
  //ŵƽBootloaderģʽ
  //ö˿Ϊ״̬
  DDRREG(LEVELPORT) &= ~(1 << LEVELPIN);
#if PINLEVEL
  if(PINREG(LEVELPORT) & (1 << LEVELPIN))
#else
  if(!(PINREG(LEVELPORT) & (1 << LEVELPIN)))
#endif
  {
#if VERBOSE
    //ģʽ
    putstr(msg6);
#endif
  }
  else
  {
#if VERBOSE
    //û
    putstr(msg7);
#endif

    quit();
  }

#else
  //Bootloaderģʽ

#if VERBOSE
  //ʾȴ
  putstr(msg1);
#endif

  cnt = TimeOutCnt;
  cl = 0;
  while(1)
  {
#if WDGEn
    //Ź
    wdt_reset();
#endif

    if(TIFRREG & (1<<OCF1A))    //T1
    {
      TIFRREG |= (1 << OCF1A);

      if(cl == CONNECTCNT)
        break;

#if LEDEn
      //LEDָʾ״̬
      LEDAlt();
#endif

      cnt--;
      if(cnt == 0)
      {

#if VERBOSE
        //ʾʱ
        putstr(msg2);
#endif
        //תû
        quit();
      }
    }

    if(DataInCom())
    {
      if(ReadCom() == KEY[cl])
        cl++;
      else
        cl = 0;
    }
  }

#endif  //LEVELMODE

#if VERBOSE
  //ʾȴļ
  putstr(msg3);
#endif

  //ÿʱ϶PCһַCȴ֡soh
  cnt = TimeOutCntC;
  while(1)
  {
    if(TIFRREG & (1 << OCF1A))  //T1
    {
      TIFRREG |= (1 << OCF1A);
      WriteCom(XMODEM_RWC) ;    // "C"

#if LEDEn
      //LEDָʾ״̬
      LEDAlt();
#endif

      cnt--;
      if(cnt == 0)
      {
#if VERBOSE
        //ʾʱ
        putstr(msg2);
#endif
        quit();
      }
    }

#if WDGEn
    //Ź
    wdt_reset();
#endif

    if(DataInCom())
    {
      if(ReadCom() == XMODEM_SOH)  //XMODEMʼ
        break;
    }
  }
  //رնʱ
  TCCR1B = 0;

  //ʼ
  packNO = 0;
  bufptr = 0;
  cnt = 0;
  FlashAddr = 0;
  do
  {
    packNO++;
    ch =  WaitCom();                          //ȡ
    cl = ~WaitCom();
    if ((packNO == ch) && (packNO == cl))
    {
      for(li = 0; li < BUFFERSIZE; li++)      //һ֡
      {
        buf[bufptr++] = WaitCom();
      }
      crch = WaitCom();
      crcl = WaitCom();
      crc16(&buf[bufptr - BUFFERSIZE]);       //У
      if((crch == ch) && (crcl == cl))
      {
#if BootStart
        if(FlashAddr < BootStart)             //дBoot
        {
#endif

#if BUFFERSIZE < SPM_PAGESIZE
          if(bufptr >= SPM_PAGESIZE)          //дݣ
          {                                   //ն֡дһҳ
            write_one_page(buf);              //д뻺ݵFlash
            FlashAddr += SPM_PAGESIZE;        //޸Flashҳַ
            bufptr = 0;
          }
#else
          while(bufptr > 0)                   //һ֡дҳ
          {
            write_one_page(&buf[BUFSIZE - bufptr]);
            FlashAddr += SPM_PAGESIZE;        //޸Flashҳַ
            bufptr -= SPM_PAGESIZE;
          }
#endif

#if BootStart
        }
        else                                  //BootStartд
        {
          bufptr = 0;                         //ýָ
        }
#endif

//ȡдFlashݲصĻȽ
#if (ChipCheck > 0) && (BootStart > 0)
#if BUFFERSIZE < SPM_PAGESIZE
        if((bufptr == 0) && (FlashAddr <= BootStart))
#else
        if(FlashAddr <= BootStart)
#endif
        {
          boot_rww_enable();                  //û
          cl = 1;                             //־
          for(pagptr = 0; pagptr < BUFSIZE; pagptr++)
          {
            if(pgm_read_byte(FlashAddr - BUFSIZE + pagptr) != buf[pagptr])
            {
              cl = 0;                         //ô־
              break;
            }
          }
          if(cl)                              //Уȷ
          {
            WriteCom(XMODEM_ACK);
            cnt = 0;
          }
          else
          {
            WriteCom(XMODEM_NAK);             //Уط
            cnt++;                            //1
            FlashAddr -= BUFSIZE;             //FlashAddrַ
          }
        }
        else                                  //УBootֱӷȷӦ
        {
          WriteCom(XMODEM_ACK);
          cnt = 0;
        }
#else
        //У飬ֱӷȷӦ
        WriteCom(XMODEM_ACK);
        cnt = 0;
#endif

#if WDGEn
        //Ź
        wdt_reset();
#endif

#if LEDEn
        //LEDָʾ״̬
        LEDAlt();
#endif
      }
      else //CRC
      {
        //Ҫطݿ
        WriteCom(XMODEM_NAK);
        cnt++;
      }
    }
    else //PackNo
    {
      //Ҫطݿ
      WriteCom(XMODEM_NAK);
      cnt++;
    }
    //ֹ̫࣬
    if(cnt > 3)
      break;
  }
  while(WaitCom() != XMODEM_EOT);
  WriteCom(XMODEM_ACK);


#if VERBOSE
  if(cnt == 0)
  {
    //ʾɹ
    putstr(msg4);
  }
  else
  {
    //ʾʧ
    putstr(msg5);

#if WDGEn
    //ȴŹλ
    while(1);
#endif

  }
#endif

  //˳Bootloader
  quit();
  return 0;
}

//End of file: bootldr.c
